Index: src/UIElements/Qt4/QtDialog.cpp
===================================================================
--- src/UIElements/Qt4/QtDialog.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Qt4/QtDialog.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,172 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * QtDialog.cpp
+ *
+ *  Created on: Jan 18, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "UIElements/Qt4/QtDialog.hpp"
+
+#include <QtGui/QDialogButtonBox>
+#include <Qt/qpushbutton.h>
+#include <Qt/qboxlayout.h>
+
+#include "Helpers/MemDebug.hpp"
+
+
+using namespace std;
+
+QtDialog::QtDialog() :
+    QDialog(0)
+{
+  // creating and filling of the Dialog window
+  mainLayout = new QVBoxLayout();
+  inputLayout = new QVBoxLayout();
+  buttonLayout = new QVBoxLayout();
+  setLayout(mainLayout);
+  mainLayout->addLayout(inputLayout);
+  mainLayout->addLayout(buttonLayout);
+  buttons = new QDialogButtonBox(QDialogButtonBox::Ok| QDialogButtonBox::Cancel);
+  buttonLayout->addWidget(buttons);
+
+  // Disable the ok button until something was entered
+  buttons->button(QDialogButtonBox::Ok)->setEnabled(false);
+
+  // connect the buttons to their appropriate slots
+  connect(buttons, SIGNAL(accepted()), this, SLOT(accept()));
+  connect(buttons, SIGNAL(rejected()), this, SLOT(reject()));
+}
+
+QtDialog::~QtDialog()
+{
+}
+
+bool QtDialog::display(){
+  // Button state might have changed by some update that
+  // was done during query construction. To make sure
+  // the state is correct, we just call update one more time.
+  update();
+  if(exec()) {
+    setAll();
+    return true;
+  }
+  else {
+    return false;
+  }
+}
+
+void QtDialog::update(){
+  buttons->button(QDialogButtonBox::Ok)->setEnabled(checkAll());
+}
+
+/************************** Query Infrastructure ************************/
+
+void QtDialog::queryEmpty(const char* title, std::string)
+{
+  registerQuery(new EmptyQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryBoolean(const char* title,string)
+{
+  registerQuery(new BooleanQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryAtom(const char* title, std::string)
+{
+  registerQuery(new AtomQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryAtoms(const char* title, std::string)
+{
+  registerQuery(new AtomsQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryBox(const char* title, std::string)
+{
+  registerQuery(new BoxQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryInt(const char *title,string)
+{
+  registerQuery(new IntQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryInts(const char *title,string)
+{
+  registerQuery(new IntsQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryDouble(const char* title,string)
+{
+  registerQuery(new DoubleQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryDoubles(const char* title,string)
+{
+  registerQuery(new DoublesQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryString(const char* title,string)
+{
+  registerQuery(new StringQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryStrings(const char* title,string)
+{
+  registerQuery(new StringsQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryMolecule(const char *title,string)
+{
+  registerQuery(new MoleculeQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryMolecules(const char *title,string)
+{
+  registerQuery(new MoleculesQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryVector(const char* title, bool check,string)
+{
+  registerQuery(new VectorQtQuery(title,check,inputLayout,this));
+}
+
+void QtDialog::queryVectors(const char* title, bool check,string)
+{
+  registerQuery(new VectorsQtQuery(title,check,inputLayout,this));
+}
+
+void QtDialog::queryElement(const char* title, std::string)
+{
+  registerQuery(new ElementQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryElements(const char* title, std::string)
+{
+  registerQuery(new ElementsQtQuery(title,inputLayout,this));
+}
+
+void QtDialog::queryFile(const char* title, std::string)
+{
+  registerQuery(new FileQtQuery(title,inputLayout,this));
+}
+
+/************************** Query Infrastructure ************************/
+/*       ---> shifted to folder Query                                   */
+/************************************************************************/
+
+/*************************** Pipe Infrastructure ************************/
+/*       ---> shifted to folder Pipe                                    */
+/************************************************************************/
Index: src/UIElements/Qt4/QtDialog.hpp
===================================================================
--- src/UIElements/Qt4/QtDialog.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Qt4/QtDialog.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,620 @@
+/*
+ * QtDialog.hpp
+ *
+ *  Created on: Jan 18, 2010
+ *      Author: crueger
+ */
+
+#ifndef QTDIALOG_HPP_
+#define QTDIALOG_HPP_
+
+#include "UIElements/Dialog.hpp"
+#include <QtGui/QDialog>
+#include <QtGui/QFileDialog>
+
+#include <boost/filesystem.hpp>
+
+#include <map>
+#include <set>
+#include <vector>
+
+class QBoxLayout;
+class QLabel;
+class QSpinBox;
+class QDoubleSpinBox;
+class QLineEdit;
+class QListWidget;
+class QTableWidget;
+class QComboBox;
+class QDialogButtonBox;
+
+class Matrix;
+
+// Forward declarations for plumbing
+template<typename T> class QtQueryListPipe;
+class BooleanQtQueryPipe;
+class BoxQtQueryPipe;
+class StringQtQueryPipe;
+class StringsQtQueryPipe;
+class IntQtQueryPipe;
+class DoubleQtQueryPipe;
+class DoublesQtQueryPipe;
+class AtomQtQueryPipe;
+class AtomsQtQueryPipe;
+class MoleculeQtQueryPipe;
+class MoleculesQtQueryPipe;
+class EmptyQtQueryPipe;
+class ElementQtQueryPipe;
+class ElementsQtQueryPipe;
+class VectorQtQueryPipe;
+class VectorsQtQueryPipe;
+class FileQtQueryPipe;
+
+class QtDialog : public QDialog, public Dialog
+{
+  Q_OBJECT
+public:
+  QtDialog();
+  virtual ~QtDialog();
+
+  virtual void queryEmpty(const char*, std::string);
+  virtual void queryBoolean(const char *, std::string = "");
+  virtual void queryInt(const char *,std::string = "");
+  virtual void queryInts(const char *,std::string = "");
+  virtual void queryDouble(const char*,std::string = "");
+  virtual void queryDoubles(const char*,std::string = "");
+  virtual void queryString(const char*,std::string = "");
+  virtual void queryStrings(const char*,std::string = "");
+  virtual void queryAtom(const char*,std::string = "");
+  virtual void queryAtoms(const char*,std::string = "");
+  virtual void queryMolecule(const char*,std::string = "");
+  virtual void queryMolecules(const char*,std::string = "");
+  virtual void queryVector(const char*,bool,std::string = "");
+  virtual void queryVectors(const char*,bool,std::string = "");
+  virtual void queryBox(const char*, std::string = "");
+  virtual void queryElement(const char*,std::string = "");
+  virtual void queryElements(const char*,std::string = "");
+  virtual void queryFile(const char*,std::string = "");
+
+  virtual bool display();
+
+  virtual void update();
+
+protected:
+  class IntQtQuery : public Dialog::IntQuery {
+    public:
+      IntQtQuery(std::string _title,QBoxLayout *_parent,QtDialog *_dialog);
+      virtual ~IntQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QSpinBox *inputBox;
+
+      IntQtQueryPipe *pipe;
+    };
+
+  class IntsQtQuery : public Dialog::IntsQuery {
+    public:
+      IntsQtQuery(std::string _title,QBoxLayout *_parent,QtDialog *_dialog);
+      virtual ~IntsQtQuery();
+      virtual bool handle();
+      void IntegerEntered(const QString&);
+      void IntegerSelected();
+      void AddInteger();
+      void RemoveInteger();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+
+      QtQueryListPipe<int> *pipe;
+    };
+
+    class DoubleQtQuery : public Dialog::DoubleQuery {
+    public:
+      DoubleQtQuery(std::string title,QBoxLayout *_parent,QtDialog *_dialog);
+      virtual ~DoubleQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QDoubleSpinBox *inputBox;
+
+      DoubleQtQueryPipe *pipe;
+    };
+
+    class DoublesQtQuery : public Dialog::DoublesQuery {
+    public:
+      DoublesQtQuery(std::string title,QBoxLayout *_parent,QtDialog *_dialog);
+      virtual ~DoublesQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QDoubleSpinBox *inputBox;
+
+      QtQueryListPipe<double> *pipe;
+    };
+
+    class StringQtQuery : public Dialog::StringQuery {
+    public:
+      StringQtQuery(std::string _title, QBoxLayout *_parent,QtDialog *_dialog);
+      virtual ~StringQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QLineEdit *inputBox;
+
+      StringQtQueryPipe *pipe;
+    };
+
+    class StringsQtQuery : public Dialog::StringsQuery {
+    public:
+      StringsQtQuery(std::string _title, QBoxLayout *_parent,QtDialog *_dialog);
+      virtual ~StringsQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QLineEdit *inputBox;
+
+      QtQueryListPipe<std::string> *pipe;
+    };
+
+    class BoxQtQuery : public Dialog::BoxQuery {
+    public:
+      BoxQtQuery(std::string _title, QBoxLayout *_parent,QtDialog *_dialog);
+      virtual ~BoxQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QTableWidget *inputTable;
+
+      BoxQtQueryPipe *pipe;
+    };
+
+    class AtomQtQuery : public Dialog::AtomQuery {
+    public:
+      AtomQtQuery(std::string _title, QBoxLayout *_parent,QtDialog *_dialog);
+      virtual ~AtomQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QComboBox *inputBox;
+
+      AtomQtQueryPipe *pipe;
+    };
+
+    class AtomsQtQuery : public Dialog::AtomsQuery {
+    public:
+      AtomsQtQuery(std::string _title, QBoxLayout *_parent,QtDialog *_dialog);
+      virtual ~AtomsQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QLabel *inputLabel;
+      QListWidget *inputList;
+
+      AtomsQtQueryPipe *pipe;
+    };
+
+    class MoleculeQtQuery : public Dialog::MoleculeQuery {
+    public:
+      MoleculeQtQuery(std::string _title, QBoxLayout *_parent,QtDialog *_dialog);
+      virtual ~MoleculeQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QComboBox *inputBox;
+
+      MoleculeQtQueryPipe *pipe;
+    };
+
+    class MoleculesQtQuery : public Dialog::MoleculesQuery {
+    public:
+      MoleculesQtQuery(std::string _title, QBoxLayout *_parent,QtDialog *_dialog);
+      virtual ~MoleculesQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QComboBox *inputBox;
+
+      MoleculesQtQueryPipe *pipe;
+    };
+
+    class VectorQtQuery : public Dialog::VectorQuery {
+    public:
+      VectorQtQuery(std::string title,bool _check,QBoxLayout *,QtDialog *);
+      virtual ~VectorQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *mainLayout;
+      QLabel *titleLabel;
+      QBoxLayout *subLayout;
+      QBoxLayout *coordLayout;
+      QLabel *coordLabel;
+      QDoubleSpinBox *coordInput;
+
+      VectorQtQueryPipe *pipe;
+    };
+
+    class VectorsQtQuery : public Dialog::VectorsQuery {
+    public:
+      VectorsQtQuery(std::string title,bool _check,QBoxLayout *,QtDialog *);
+      virtual ~VectorsQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *mainLayout;
+      QLabel *titleLabel;
+      QBoxLayout *subLayout;
+      QBoxLayout *coordLayout;
+      QLabel *coordLabel;
+      QDoubleSpinBox *coordInput;
+
+      VectorsQtQueryPipe *pipe;
+    };
+
+    class EmptyQtQuery : public Dialog::EmptyQuery {
+    public:
+      EmptyQtQuery(std::string _title, QBoxLayout *_parent, QtDialog *_dialog);
+      virtual ~EmptyQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+
+      EmptyQtQueryPipe *pipe;
+    };
+
+    class BooleanQtQuery : public Dialog::BooleanQuery {
+    public:
+      BooleanQtQuery(std::string _title, QBoxLayout *_parent, QtDialog *_dialog);
+      virtual ~BooleanQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QComboBox *booleanComboBox;
+
+      BooleanQtQueryPipe *pipe;
+    };
+
+    class ElementQtQuery : public Dialog::ElementQuery {
+    public:
+      ElementQtQuery(std::string _title, QBoxLayout *_parent, QtDialog *_dialog);
+      virtual ~ElementQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QComboBox *inputBox;
+
+      ElementQtQueryPipe *pipe;
+    };
+
+    class ElementsQtQuery : public Dialog::ElementsQuery {
+    public:
+      ElementsQtQuery(std::string _title, QBoxLayout *_parent, QtDialog *_dialog);
+      virtual ~ElementsQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *titleLabel;
+      QComboBox *inputBox;
+
+      ElementsQtQueryPipe *pipe;
+    };
+
+    class FileQtQuery : public Dialog::FileQuery {
+    public:
+      FileQtQuery(std::string _title, QBoxLayout *_parent, QtDialog *_dialog);
+      virtual ~FileQtQuery();
+      virtual bool handle();
+    private:
+      QBoxLayout *parent;
+      QBoxLayout *thisLayout;
+      QLabel *filenameLabel;
+      QLineEdit *filenameLineEdit;
+      QPushButton *filedialogButton;
+
+      FileQtQueryPipe *pipe;
+    };
+
+private:
+  QBoxLayout *mainLayout;
+  QBoxLayout *inputLayout;
+  QBoxLayout *buttonLayout;
+  QDialogButtonBox *buttons;
+};
+
+// All kinds of plumbing for Queries
+// Plumbing needs to be outside of the class where it is needed,
+// since MOC doesn't like nested classes
+
+
+template<typename T> class QtQueryListPipe : public QWidget {
+  public:
+    QtQueryListPipe(std::vector<T> *_content, QtDialog *_dialog, QLineEdit *_inputBox, QListWidget *_inputList, QPushButton *_AddButton, QPushButton *_RemoveButton);
+    virtual ~QtQueryListPipe();
+    void AddInteger();
+    void RemoveInteger();
+    void IntegerSelected();
+    void IntegerEntered(const QString&);
+
+  private:
+    void AddValue(T item);
+    void RemoveRow(int row);
+
+    std::vector<T> *content;
+    QtDialog *dialog;
+    QLineEdit *inputBox;
+    QListWidget *inputList;
+    QPushButton *AddButton;
+    QPushButton *RemoveButton;
+};
+
+
+class StringQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  StringQtQueryPipe(std::string *_content, QtDialog *_dialog);
+  virtual ~StringQtQueryPipe();
+
+public slots:
+  void update(const QString&);
+
+private:
+  std::string *content;
+  QtDialog *dialog;
+
+};
+
+class IntQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  IntQtQueryPipe(int *_content, QtDialog *_dialog);
+  virtual ~IntQtQueryPipe();
+
+public slots:
+  void update(int);
+
+private:
+  int *content;
+  QtDialog *dialog;
+
+};
+
+
+class DoubleQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  DoubleQtQueryPipe(double *_content, QtDialog *_dialog);
+  virtual ~DoubleQtQueryPipe();
+
+public slots:
+  void update(double);
+
+private:
+  double *content;
+  QtDialog *dialog;
+
+};
+
+class BoxQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  BoxQtQueryPipe(Box &_content, QtDialog *_dialog, QTableWidget *_inputTable);
+  virtual ~BoxQtQueryPipe();
+
+public slots:
+  void update(int,int);
+
+private:
+  Box &content;
+  QtDialog *dialog;
+  QTableWidget *inputTable;
+
+  Matrix *tmpM;
+};
+
+
+class AtomQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  AtomQtQueryPipe(atom **_content, QtDialog *_dialog, QComboBox *_theBox);
+  virtual ~AtomQtQueryPipe();
+
+public slots:
+  void update(int);
+
+private:
+  atom **content;
+  QtDialog *dialog;
+  QComboBox *theBox;
+
+};
+
+
+class AtomsQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  AtomsQtQueryPipe(std::vector<atom *>*_content, QtDialog *_dialog, QListWidget *_theList);
+  virtual ~AtomsQtQueryPipe();
+
+public slots:
+  void update();
+  void add();
+  void remove();
+
+private:
+  std::vector<atom *>*content;
+  std::map<int, atom *> lookup;
+  std::set<atom *> currentList;
+  QtDialog *dialog;
+  QListWidget *theList;
+
+};
+
+class MoleculeQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  MoleculeQtQueryPipe(molecule **_content, QtDialog *_dialog, QComboBox *_theBox);
+  virtual ~MoleculeQtQueryPipe();
+
+public slots:
+  void update(int);
+
+private:
+  molecule **content;
+  QtDialog *dialog;
+  QComboBox *theBox;
+
+};
+
+class MoleculesQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  MoleculesQtQueryPipe(std::vector<molecule *>*_content, QtDialog *_dialog, QComboBox *_theBox);
+  virtual ~MoleculesQtQueryPipe();
+
+public slots:
+  void update(int);
+
+private:
+  std::vector<molecule *>*content;
+  QtDialog *dialog;
+  QComboBox *theBox;
+
+};
+
+class VectorQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  VectorQtQueryPipe(Vector *_content, QtDialog *_dialog, QComboBox *_theBox);
+  virtual ~VectorQtQueryPipe();
+
+public slots:
+  void update();
+
+private:
+  Vector *content;
+  QtDialog *dialog;
+  QComboBox *theBox;
+};
+
+class VectorsQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  VectorsQtQueryPipe(std::vector<Vector>*_content, QtDialog *_dialog, QComboBox *_theBox);
+  virtual ~VectorsQtQueryPipe();
+
+public slots:
+  void update();
+
+private:
+  std::vector<Vector> *content;
+  QtDialog *dialog;
+  QComboBox *theBox;
+};
+
+class EmptyQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  EmptyQtQueryPipe(QtDialog *_dialog, QLabel *_textLabel);
+  virtual ~EmptyQtQueryPipe();
+
+public slots:
+  void update();
+
+private:
+  QtDialog *dialog;
+  QLabel *textLabel;
+};
+
+class BooleanQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  BooleanQtQueryPipe(const bool *_content, QtDialog *_dialog, QComboBox *_booleanComboBox);
+  virtual ~BooleanQtQueryPipe();
+
+public slots:
+  void update();
+
+private:
+  const bool *content;
+  QtDialog *dialog;
+  QComboBox *booleanComboBox;
+};
+
+class ElementQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  ElementQtQueryPipe(const element **_content, QtDialog *_dialog, QComboBox *_theBox);
+  virtual ~ElementQtQueryPipe();
+
+public slots:
+  void update(int);
+
+private:
+  const element **content;
+  QtDialog *dialog;
+  QComboBox *theBox;
+};
+
+class ElementsQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  ElementsQtQueryPipe(std::vector<const element *>*_content, QtDialog *_dialog, QComboBox *_theBox);
+  virtual ~ElementsQtQueryPipe();
+
+public slots:
+  void update(int);
+
+private:
+  std::vector<const element *>*content;
+  QtDialog *dialog;
+  QComboBox *theBox;
+};
+
+class FileQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  FileQtQueryPipe(boost::filesystem::path *_content, QtDialog *_dialog, QLineEdit *_filenameLineEdit, QPushButton *_filedialogButton);
+  virtual ~FileQtQueryPipe();
+
+public slots:
+  void update();
+  void showFileDialog();
+
+private:
+  boost::filesystem::path *content;
+  QtDialog *dialog;
+  QLineEdit *filenameLineEdit;
+  QPushButton *filedialogButton;
+  QFileDialog *theFileDialog;
+};
+
+#endif /* QTDIALOG_HPP_ */
Index: src/UIElements/Qt4/QtMainWindow.cpp
===================================================================
--- src/UIElements/Qt4/QtMainWindow.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Qt4/QtMainWindow.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,133 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * QtMainWindow.cpp
+ *
+ *  Created on: Jan 14, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "QtMainWindow.hpp"
+
+#include<Qt/qapplication.h>
+#include<Qt/qlabel.h>
+#include<Qt/qstring.h>
+#include<Qt/qmenubar.h>
+#include<Qt/qsplitter.h>
+
+#include<iostream>
+#include<map>
+
+#include<boost/bind.hpp>
+
+#include "Helpers/MemDebug.hpp"
+
+#include "atom.hpp"
+#include "molecule.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Actions/Action.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Actions/MapOfActions.hpp"
+#include "Menu/Menu.hpp"
+#include "Menu/Qt4/QtMenu.hpp"
+#include "Menu/ActionMenuItem.hpp"
+#include "Views/Qt4/QtWorldView.hpp"
+#include "Views/Qt4/GLMoleculeView.hpp"
+#include "Views/Qt4/QtMoleculeView.hpp"
+#include "Views/Qt4/QtStatusBar.hpp"
+
+using namespace std;
+
+QtMainWindow::QtMainWindow(QApplication *_theApp) :
+    theApp(_theApp)
+{
+  QSplitter *splitter1 = new QSplitter (Qt::Horizontal, this );
+  QSplitter *splitter2 = new QSplitter (Qt::Vertical, splitter1 );
+
+  worldDisplay = new QtWorldView(splitter2);
+
+  moleculeDisplay = new QtMoleculeView();
+  molecule3dDisplay = new GLMoleculeView();
+
+  MenuBar = menuBar();
+
+  std::map <std::string, QtMenu *> NametoTextMenuMap;
+  // go through all menus and create them
+  QtMenu *Menu = NULL;
+  for(std::map<std::string, std::pair<std::string,std::string> >::iterator iter = MapOfActions::getInstance().MenuDescription.begin(); iter != MapOfActions::getInstance().MenuDescription.end(); ++iter) {
+    cout << "Creating menu " << iter->first << endl;
+    Menu = new QtMenu(iter->first.c_str());
+    MenuBar->addMenu(Menu);
+    NametoTextMenuMap.insert( pair <std::string, QtMenu *> (iter->first, Menu) );
+    //new SubMenuItem(getSuitableShortForm(iter->first),iter->second.first,main_menu,Menu);
+  }
+
+  // populate all actions
+  MapOfActions::getInstance().populateActions();
+
+  // go through all actions and add them to its menu
+  for (std::map <std::string, QtMenu *>::iterator MenuRunner = NametoTextMenuMap.begin(); MenuRunner != NametoTextMenuMap.end(); ++MenuRunner) {
+    cout << "Creating Action " << MenuRunner->first << " in menu " << MenuRunner->second << endl;
+    populateMenu(MenuRunner->second, MenuRunner->first);
+  }
+
+  setCentralWidget(splitter1);
+  splitter1->addWidget(splitter2);
+  splitter1->addWidget(moleculeDisplay);
+  splitter2->addWidget(molecule3dDisplay);
+  splitter2->addWidget(worldDisplay);
+
+  statusBar = new QtStatusBar(this);
+  setStatusBar(statusBar);
+
+  connect(worldDisplay,SIGNAL(moleculeSelected(molecule*)),moleculeDisplay,SLOT(moleculeSelected(molecule*)));
+  connect(worldDisplay,SIGNAL(moleculeUnSelected(molecule*)),moleculeDisplay,SLOT(moleculeUnSelected(molecule*)));
+}
+
+QtMainWindow::~QtMainWindow()
+{
+  menuBar()->clear();
+  delete editMoleculesMenu;
+}
+
+void QtMainWindow::display() {
+  this->show();
+  theApp->exec();
+}
+
+char QtMainWindow::getSuitableShortForm(set <char> &ShortcutList, const std::string name) const
+{
+  for (std::string::const_iterator CharRunner = name.begin(); CharRunner != name.end(); ++CharRunner) {
+    if (ShortcutList.find(*CharRunner) == ShortcutList.end())
+      return *CharRunner;
+  }
+  DoeLog(1) && (eLog() << Verbose(1) << "Could not find a suitable shortform for TextWindow::getSuitableShortForm()." << endl);
+  return ((char)(ShortcutList.size() % 10) + '0');
+}
+
+void QtMainWindow::populateMenu(QtMenu* Menu, const  std::string &MenuName)
+{
+  Action *ActionItem = NULL;
+  set <char> ShortcutList;
+  // through all actions for this menu
+  std::pair < std::multimap <std::string, std::string>::iterator, std::multimap <std::string, std::string>::iterator > MenuActions = MapOfActions::getInstance().MenuContainsActionMap.equal_range(MenuName);
+  for (std::multimap <std::string, std::string>::const_iterator MenuRunner = MenuActions.first; MenuRunner != MenuActions.second; ++MenuRunner) {
+    cout << " Adding " << MenuRunner->second << " to submenu " << MenuName << endl;
+    ActionItem = ActionRegistry::getInstance().getActionByName(MenuRunner->second);
+    new ActionMenuItem(getSuitableShortForm(ShortcutList, MenuRunner->second),MapOfActions::getInstance().getDescription(MenuRunner->second).c_str(),Menu,ActionItem);
+  }
+  // finally add default quit item
+  //Action *returnFromAction = new TextMenu::LeaveAction(Menu);
+  //MenuItem *returnFromItem = new ActionMenuItem('q',"return to Main menu",Menu,returnFromAction);
+  //Menu->addDefault(returnFromItem);
+}
Index: src/UIElements/Qt4/QtMainWindow.hpp
===================================================================
--- src/UIElements/Qt4/QtMainWindow.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Qt4/QtMainWindow.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,48 @@
+/*
+ * QtMainWindow.hpp
+ *
+ *  Created on: Jan 14, 2010
+ *      Author: crueger
+ */
+
+#ifndef QTMAINWINDOW_HPP_
+#define QTMAINWINDOW_HPP_
+
+#include "UIElements/MainWindow.hpp"
+#include <QtGui/QMainWindow>
+
+#include <set>
+
+class QtWorldView;
+class StringView;
+class QtMenu;
+class GLMoleculeView;
+class QtMoleculeView;
+class QtStatusBar;
+
+class QtMainWindow : public QMainWindow, public MainWindow
+{
+  Q_OBJECT
+
+public:
+  QtMainWindow(QApplication *_theApp);
+  virtual ~QtMainWindow();
+
+  virtual void display();
+
+  char getSuitableShortForm(std::set <char> &ShortcutList, const std::string name) const;
+  void populateMenu(QtMenu* Menu, const  std::string &MenuName);
+
+private:
+  // All kinds of QTStuff used in this window
+  QApplication *theApp;
+  QtWorldView *worldDisplay;
+  QtMenu *editMoleculesMenu;
+  GLMoleculeView *molecule3dDisplay;
+  QtMoleculeView *moleculeDisplay;
+  QtStatusBar *statusBar;
+  QMenuBar *MenuBar;
+
+};
+
+#endif /* QTMAINWINDOW_HPP_ */
Index: src/UIElements/Qt4/QtUIFactory.cpp
===================================================================
--- src/UIElements/Qt4/QtUIFactory.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Qt4/QtUIFactory.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,71 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * QtUIFactory.cpp
+ *
+ *  Created on: Jan 14, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <iostream>
+#include <cassert>
+
+#include <qapplication.h>
+
+
+#include "UIElements/Qt4/QtUIFactory.hpp"
+#include "UIElements/Qt4/QtMainWindow.hpp"
+#include "UIElements/Qt4/QtDialog.hpp"
+
+#include "Helpers/MemDebug.hpp"
+
+#include "version.h"
+#include "defs.hpp"
+
+using namespace std;
+
+QtUIFactory::QtUIFactory() :
+  argc(1)
+{
+  // For now we just fake the command line parameters to make QT happy
+  argv = new char*[1];
+  argv[0] = new char[256];
+  strcpy(argv[0],MOLECUILDERVERSION);
+  app = new QApplication(argc,argv);
+}
+
+QtUIFactory::~QtUIFactory()
+{
+  delete app;
+  delete [] argv[0];
+  delete [] argv;
+}
+
+Dialog* QtUIFactory::makeDialog() {
+  return new QtDialog();
+}
+
+MainWindow* QtUIFactory::makeMainWindow() {
+  return new QtMainWindow(app);
+}
+
+QtUIFactory::description::description() :
+    UIFactory::factoryDescription("Qt4")
+{}
+
+QtUIFactory::description::~description()
+{}
+
+UIFactory* QtUIFactory::description::makeFactory(){
+  return new QtUIFactory();
+}
Index: src/UIElements/Qt4/QtUIFactory.hpp
===================================================================
--- src/UIElements/Qt4/QtUIFactory.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Qt4/QtUIFactory.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,42 @@
+/*
+ * QtUIFactory.hpp
+ *
+ *  Created on: Jan 14, 2010
+ *      Author: crueger
+ */
+
+#ifndef QTUIFACTORY_HPP_
+#define QTUIFACTORY_HPP_
+
+#include "UIElements/UIFactory.hpp"
+
+class QApplication;
+
+class QtUIFactory : public UIFactory
+{
+  friend class UIFactory;
+
+public:
+  virtual ~QtUIFactory();
+
+  virtual Dialog* makeDialog();
+  virtual MainWindow* makeMainWindow();
+
+  struct description : public UIFactory::factoryDescription {
+    description();
+    virtual ~description();
+
+    virtual UIFactory* makeFactory();
+  };
+
+protected:
+  QtUIFactory();
+
+private:
+  // faked command line arguments
+  int argc;
+  char **argv;
+  QApplication *app;
+};
+
+#endif /* QTUIFACTORY_HPP_ */
Index: src/UIElements/Qt4/Query/AtomQtQuery.cpp
===================================================================
--- src/UIElements/Qt4/Query/AtomQtQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Qt4/Query/AtomQtQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,61 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * AtomQtQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <Qt/qboxlayout.h>
+#include <Qt/qcombobox.h>
+#include <Qt/qlabel.h>
+
+#include "Helpers/MemDebug.hpp"
+
+#include "UIElements/Qt4/QtDialog.hpp"
+
+#include "atom.hpp"
+#include "World.hpp"
+
+QtDialog::AtomQtQuery::AtomQtQuery(string _title,QBoxLayout *_parent,QtDialog *_dialog) :
+    Dialog::AtomQuery(_title),
+    parent(_parent)
+{
+  thisLayout = new QHBoxLayout();
+  titleLabel = new QLabel(QString(getTitle().c_str()));
+  inputBox = new QComboBox();
+  inputBox->insertItem(-1, QString("no atom"));
+  std::vector<atom *> atoms = World::getInstance().getAllAtoms();
+  for (std::vector<atom *>::const_iterator iter = atoms.begin(); iter != atoms.end(); ++iter)
+    inputBox->insertItem((*iter)->getNr(),QString::fromStdString((*iter)->getName()));
+
+  parent->addLayout(thisLayout);
+  thisLayout->addWidget(titleLabel);
+  thisLayout->addWidget(inputBox);
+
+  pipe = new AtomQtQueryPipe(&tmp,_dialog, inputBox);
+  pipe->update(inputBox->currentIndex());
+  connect(inputBox,SIGNAL(currentIndexChanged(int)),pipe,SLOT(update(int)));
+}
+
+QtDialog::AtomQtQuery::~AtomQtQuery()
+{
+  delete pipe;
+}
+
+bool QtDialog::AtomQtQuery::handle() {
+  return true;
+}
+
+
